###########################################################################
#
# win32.mak -- Windows Makefile for runtime-src\src\oaiservr
#
# By Michael Dewsnip
#
# Copyright (C) 2010  DL Consulting Ltd.
#
###########################################################################


GSDL_DIR = $(GSDLHOME)


# Programs compiled and their install directories
CGIBIN_DIR = "$(GSDL_DIR)\cgi-bin"
CGIBIN_PROGRAMS = oaiserver.cgi

# Program: oaiserver.cgi
OAISERVER_CGI_CPPFLAGS = \
	-I"$(GSDL_DIR)\common-src\src\lib" \
	-I"$(GSDL_DIR)\runtime-src\src\colservr" \
	-I"$(GSDL_DIR)\runtime-src\src\protocol" \
	-I"$(GSDL_DIR)\runtime-src\src\recpt"

# Objects for oaiserver.cgi
OAISERVER_CGI_OBJECTS = \
	"$(GSDL_DIR)\runtime-src\src\recpt\cgiargs.obj" \
	"$(GSDL_DIR)\runtime-src\src\recpt\cgiutils.obj" \
	"$(GSDL_DIR)\runtime-src\src\recpt\htmlutils.obj" \
	abstractlistaction.obj \
	dublincore.obj \
	qualified_dublincore.obj \
	identifyaction.obj \
	listidsaction.obj \
	listrecsaction.obj \
	listsetsaction.obj \
	metaformat.obj \
	metaformatsaction.obj \
	oaiaction.obj \
	oaiargs.obj \
	oaiconfig.obj \
	oaidispatcher.obj \
	oaimain.obj \
	oaitools.obj \
	recordaction.obj \
	resumptiontoken.obj \
	rfc1807.obj

OAISERVER_CGI_LDADD = \
	"$(GSDL_DIR)\runtime-src\src\protocol\gsdlprotocol.lib" \
	"$(GSDL_DIR)\runtime-src\src\colservr\gsdlcolservr.lib" \
	"$(GSDL_DIR)\common-src\src\lib\gsdllib.lib"


# Option: Lucene support
!IF $(ENABLE_LUCENE)
OAISERVER_CGI_LDADD = $(OAISERVER_CGI_LDADD) "$(GSDL_DIR)\common-src\packages\windows\expat\expat\libexpat.lib"
!ENDIF

# Option: SQLite support
!IF $(USE_SQLITE)
OAISERVER_CGI_LDADD = $(OAISERVER_CGI_LDADD) "$(GSDL_DIR)\common-src\packages\sqlite\lib\sqlite3.lib"
!ENDIF


COMPILE = cl -nologo -c -EHsc -D__WIN32__ -DXML_STATIC -D_CRT_SECURE_NO_DEPRECATE $(OAISERVER_CGI_CPPFLAGS)
LINK = cl -nologo -Fe"$@"

.SUFFIXES:
.SUFFIXES: .cpp .obj

{}.cpp{}.obj:
	$(COMPILE) $<


oaiserver.cgi: $(OAISERVER_CGI_OBJECTS) $(OAISERVER_CGI_LDADD)
	$(LINK) $(OAISERVER_CGI_OBJECTS) $(OAISERVER_CGI_LDADD)

all: $(CGIBIN_PROGRAMS)

install: $(CGIBIN_PROGRAMS)
	copy $(CGIBIN_PROGRAMS) $(CGIBIN_DIR)

distclean:
	del *.obj $(CGIBIN_PROGRAMS) win32.mak

clean:
	del *.obj $(CGIBIN_PROGRAMS)
